package com.seeyon.cap4.template.service;

package ..deTemp.1749451230906;

import com.google.common.collect.Sets;
import com.seeyon.apps.collaboration.po.ColSummary;
import com.seeyon.cap4.component.hook.HookUtil;
import com.seeyon.cap4.component.hook.bean.AbstractHookParamBean;
import com.seeyon.cap4.component.hook.bean.CAPDataRelationParamBean;
import com.seeyon.cap4.component.hook.bean.CAPRelationSelectConditionBean;
import com.seeyon.cap4.component.hook.bean.DataHookContextBean;
import com.seeyon.cap4.component.hook.definition.CAPFormRelationDataHook;
import com.seeyon.cap4.component.hook.definition.CAPFormRelationParmaHook;
import com.seeyon.cap4.component.hook.definition.CAPRelationSelectConditionHook;
import com.seeyon.cap4.component.hook.result.AbstractHookResult;
import com.seeyon.cap4.component.hook.result.DataRelationDataResult;
import com.seeyon.cap4.component.hook.result.DataRelationTreeParamResult;
import com.seeyon.cap4.form.bean.FormAuthViewBean;
import com.seeyon.cap4.form.bean.FormBean;
import com.seeyon.cap4.form.bean.FormDataBean;
import com.seeyon.cap4.form.bean.FormDataMasterBean;
import com.seeyon.cap4.form.bean.FormDataSubBean;
import com.seeyon.cap4.form.bean.FormFieldBean;
import com.seeyon.cap4.form.bean.FormFieldComEnum;
import com.seeyon.cap4.form.bean.FormQueryTypeEnum;
import com.seeyon.cap4.form.bean.FormRelationshipBean;
import com.seeyon.cap4.form.bean.FormRelationshipMapBean;
import com.seeyon.cap4.form.bean.FormTableBean;
import com.seeyon.cap4.form.bean.FormViewBean;
import com.seeyon.cap4.form.bean.SimpleObjectBean;
import com.seeyon.cap4.form.bean.context.AutoRelationTipBean;
import com.seeyon.cap4.form.bean.context.CalcContextBean;
import com.seeyon.cap4.form.bean.fieldCtrl.FormFieldCtrl;
import com.seeyon.cap4.form.bean.fieldCtrl.FormFieldCustomCtrl;
import com.seeyon.cap4.form.bean.fieldCtrl.FormFieldCustomCtrlReportInfo;
import com.seeyon.cap4.form.bean.fieldCtrl.FormFieldCustomCtrlRunInfo;
import com.seeyon.cap4.form.modules.engin.relation.FormRelationEnums;
import com.seeyon.cap4.form.modules.engin.relation.bo.CAP4RelationQueryParamsBO;
import com.seeyon.cap4.form.po.CAPFormRelationRecord;
import com.seeyon.cap4.form.util.Enums;
import com.seeyon.cap4.form.util.FormSearchUtil;
import com.seeyon.cap4.magic.execute.ICAP4MagicExecuteManager;
import com.seeyon.cap4.runlog.bo.FieldDataChangeBO;
import com.seeyon.cap4.runlog.constant.HistoryDataEnums;
import com.seeyon.cap4.template.annotation.ResultModifiedClass;
import com.seeyon.cap4.template.annotation.ValidateRequestParam;
import com.seeyon.cap4.template.bean.CustomCtlBean;
import com.seeyon.cap4.template.bean.FilterFieldBean;
import com.seeyon.cap4.template.bean.LockObjectBean;
import com.seeyon.cap4.template.bean.MergeDataParamBean;
import com.seeyon.cap4.template.bean.PageParamBean;
import com.seeyon.cap4.template.bean.RelationParamBean;
import com.seeyon.cap4.template.constant.CAPBusinessEnum;
import com.seeyon.cap4.template.constant.CAPCodeMessageEnum;
import com.seeyon.cap4.template.handler.HandlerFactory;
import com.seeyon.cap4.template.manager.CAPFilterFieldManager;
import com.seeyon.cap4.template.service.AbstractCAPFormDataService;
import com.seeyon.cap4.template.util.CAPAttachmentUtil;
import com.seeyon.cap4.template.util.CAPCommonUtil;
import com.seeyon.cap4.template.util.CAPFormDataLogUtil;
import com.seeyon.cap4.template.util.CAPFormUtil;
import com.seeyon.cap4.template.util.CAPParamUtil;
import com.seeyon.cap4.template.vo.FilterFieldVO;
import com.seeyon.cap4.template.vo.FormCalcResultVO;
import com.seeyon.cap4.template.vo.FormTableCalcDataVO;
import com.seeyon.ctp.common.AppContext;
import com.seeyon.ctp.common.ModuleType;
import com.seeyon.ctp.common.base.result.ServiceResult;
import com.seeyon.ctp.common.config.PerformanceConfig;
import com.seeyon.ctp.common.exceptions.BusinessException;
import com.seeyon.ctp.common.i18n.ResourceUtil;
import com.seeyon.ctp.common.log.CtpLogFactory;
import com.seeyon.ctp.util.FlipInfo;
import com.seeyon.ctp.util.Strings;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Objects;
import java.util.Set;
import javax.inject.Inject;
import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.collections.MapUtils;
import org.apache.commons.lang3.StringUtils;
import org.apache.commons.logging.Log;
import org.springframework.beans.BeanUtils;

@ResultModifiedClass
public class CAPFormRelationService extends AbstractCAPFormDataService {
  private static final Log LOGGER = CtpLogFactory.getLog(com.seeyon.cap4.template.service.CAPFormRelationService.class);
  
  private static final String CODE13 = "2013";
  
  private static final String MESSAGE13 = "cap.template.relation.ship.disabled";
  
  private static final String MESSAGE14 = "cap.template.relation.record.missing";
  
  private static final String RELATION_SHIP_ID = "relationShipId";
  
  private static final String RELATION_DATA = "relationData";
  
  private static final String CLEAN_CACHE_RELATION_DATA = "cleanCacheRelationData";
  
  @Inject
  private CAPFilterFieldManager capFilterFieldManager;
  
  @ValidateRequestParam(notEmpty = {"relationShipId", "rightId", "formId"}, validateCacheBeanKey = "formMasterId")
  public ServiceResult refreshSubData(RelationParamBean relationParamBean) throws BusinessException {
    FormBean formBean = this.cap4FormCacheManager.getForm(relationParamBean.getFormId().longValue());
    FormDataMasterBean cacheFormDataMasterBean = this.cap4FormManager.getSessioMasterDataBean(relationParamBean.getFormMasterId());
    mergeFormData(cacheFormDataMasterBean, relationParamBean.getMergeDataBean());
    FormRelationshipBean formRelationshipBean = this.cap4FormCacheManager.getFormRelationshipBean(relationParamBean.getRelationShipId().longValue());
    if (formRelationshipBean == null || formRelationshipBean.getState() == 0)
      throw businessException(CAPCodeMessageEnum.EXCEPTION.getCode(), ResourceUtil.getString(CAPCodeMessageEnum.EXCEPTION.getMessage()) + "formRelationshipBean is null or state error"); 
    FormRelationshipMapBean formRelationshipMapBean = formRelationshipBean.getRelationMapList().get(0);
    FormAuthViewBean formAuthViewBean = CAPFormUtil.getFormAuthViewBean(formBean, cacheFormDataMasterBean, relationParamBean.getRightId());
    try {
      LOGGER.info("refreshSubData data:" + cacheFormDataMasterBean.getId() + ",relation:" + formRelationshipMapBean.export4Log());
      Map<String, List<FormDataSubBean>> formDataSubBeanMaps = null;
      Map<String, Set<String>> tableName2DeleteIds = new HashMap<>();
      if (!this.cap4FormRelationActionManager.isPreConditionSatisfied(formBean, cacheFormDataMasterBean, formRelationshipMapBean))
        return ServiceResult.buildWithData(null)
          .success(CAPBusinessEnum.ResultState.FAIL_WARN.getState())
          .code(CAPCodeMessageEnum.RELATION_PRECONDITION_WARN.getCode())
          .message(ResourceUtil.getString(CAPCodeMessageEnum.RELATION_PRECONDITION_WARN.getMessage(), formRelationshipBean.getName()))
          .build(); 
      if (formRelationshipBean.getRelationType() == FormRelationEnums.ViewSelectType.auto_collect.getKey() || formRelationshipBean.getRelationType() == FormRelationEnums.ViewSelectType.condition_collect.getKey()) {
        formDataSubBeanMaps = this.cap4FormRelationActionManager.getRelationAutoSummaryFromSelf(formBean, cacheFormDataMasterBean, formAuthViewBean, formRelationshipMapBean, tableName2DeleteIds);
      } else if (formRelationshipBean.getRelationType() == FormRelationEnums.ViewSelectType.auto_increase_row.getKey()) {
        formDataSubBeanMaps = this.cap4FormRelationActionManager.getRelationAutoIncreaseRow(formBean, cacheFormDataMasterBean, formAuthViewBean, formRelationshipMapBean, tableName2DeleteIds, null);
      } 
      Map<String, FormTableCalcDataVO> tableName2DataMaps = new HashMap<>();
      CalcContextBean contextBean = new CalcContextBean(formBean, formAuthViewBean);
      if (formDataSubBeanMaps != null && formDataSubBeanMaps.size() > 0) {
        Set<String> fillBackFields = this.capRuntimeCalcManager.execCalcAll(contextBean, cacheFormDataMasterBean, CAPFormUtil.getTableName2FormSubDataBeanIds(formDataSubBeanMaps));
        Map<String, List<FormDataSubBean>> tableName2AddSubBeans = new HashMap<>();
        Map<String, Integer> appointPage = new HashMap<>();
        formDataSubBeanMaps.forEach((tableName, dataSubBeans) -> {
              tableName2AddSubBeans.put(tableName, cacheFormDataMasterBean.getSubData(tableName));
              appointPage.put(tableName, Integer.valueOf(1));
            });
        this.capRuntimeCalcManager.buildCalcAllResult(formBean, cacheFormDataMasterBean, formAuthViewBean, tableName2AddSubBeans, fillBackFields, CAPBusinessEnum.SubBeanNewFrom.FRONT_COLLECT_OR_INCREASE, tableName2DataMaps);
        mergeAutoDelete2Result(tableName2DeleteIds, tableName2DataMaps);
        this.capRuntimeCalcManager.fillTablePageData(formBean, cacheFormDataMasterBean, formAuthViewBean, relationParamBean.getMergeDataBean().getPageInfo(), tableName2DataMaps, formDataSubBeanMaps
            .keySet(), appointPage);
      } 
      FormCalcResultVO resultData = new FormCalcResultVO(tableName2DataMaps);
      ServiceResult<FormCalcResultVO> result = (new ServiceResult.ServiceResultBuilder()).success().data(resultData).build();
      HandlerFactory.buildResultHandler(contextBean, cacheFormDataMasterBean, result);
      this.cap4FormManager.putMasterDataBean2Cache(cacheFormDataMasterBean.getId(), cacheFormDataMasterBean);
      return result;
    } catch (Exception e) {
      LOGGER.error("refreshSubData is error " + e.getMessage(), e);
      throw e;
    } 
  }
  
  private void dealRelationData(FormRelationshipMapBean formRelationshipMapBean, Map<String, Object> map, FormBean formBean, FormDataMasterBean formDataMasterBean, FormDataSubBean formDataSubBean, Map<String, String> summaryId2Subject, boolean isUpdate) throws BusinessException {
    if (map.get("relationData") == null) {
      LOGGER.error(formDataMasterBean.getId() + " 手动关联回填无数据");
      return;
    } 
    Map<String, Object> relationData = (Map<String, Object>)map.get("relationData");
    Map<String, String> fieldMap = formRelationshipMapBean.getFormRelationFieldMap();
    Iterator<String> iterator = fieldMap.keySet().iterator();
    Map<String, Object> changeField = new HashMap<>();
    while (iterator.hasNext()) {
      String fromFieldName = iterator.next();
      FormFieldBean fromFormFieldBean = formBean.getFieldBeanByName(fromFieldName);
      Object fieldValue = null;
      if (FormRelationEnums.SpecialRelationItem.FLOW_NAME.getKey().equals(fieldMap.get(fromFieldName))) {
        String summaryId = (String)map.get("summaryId");
        if (Strings.isNotBlank(summaryId) && !"0".equals(summaryId)) {
          if (summaryId2Subject.containsKey(summaryId)) {
            fieldValue = summaryId2Subject.get(summaryId);
          } else {
            ColSummary colSummary = this.collaborationApi.getColSummary(Long.valueOf(summaryId));
            fieldValue = (colSummary == null) ? null : colSummary.getSubject();
            summaryId2Subject.put(summaryId, (colSummary == null) ? null : colSummary.getSubject());
          } 
        } else {
          LOGGER.error(formDataMasterBean.getId() + " 手动关联选择流程 summaryId " + summaryId);
        } 
      } else {
        Map<String, Object> fieldValueMap = (Map<String, Object>)relationData.get(fromFieldName);
        fieldValue = fieldValueMap.get("value");
        if (Enums.FieldType.DATETIME.getKey().equals(fromFormFieldBean.getFieldType()) || Enums.FieldType.TIMESTAMP.getKey().equals(fromFormFieldBean.getFieldType()))
          if (Strings.isBlank(String.valueOf(fieldValueMap.get("showValue2")))) {
            fieldValue = null;
          } else {
            Object[] values = fromFormFieldBean.getDisplayValue(fieldValueMap.get("showValue2"));
            fieldValue = values[0];
          }  
      } 
      FormDataBean formDataBean = (formDataSubBean != null) ? (FormDataBean)formDataSubBean : (FormDataBean)formDataMasterBean;
      if ((fromFormFieldBean.isAttachment() || fromFormFieldBean.isMap()) && fieldValue != null && Strings.isNotBlank(String.valueOf(fieldValue))) {
        Long subReference = Long.valueOf(Long.parseLong(String.valueOf(fieldValue)));
        Long newSubReference = null;
        if (fromFormFieldBean.isMap()) {
          Long subDataId = (formDataSubBean != null) ? formDataBean.getId() : null;
          newSubReference = CAPFormUtil.copyLBS(formBean.getId(), formDataMasterBean.getId(), subDataId, subReference, fromFormFieldBean);
        } 
        if (fromFormFieldBean.isAttachment())
          newSubReference = CAPAttachmentUtil.copyAttachment(formDataMasterBean, fromFormFieldBean, subReference, formDataMasterBean.getId(), newSubReference, false); 
        fieldValue = newSubReference;
      } 
      Object oldValue = null;
      if (fromFormFieldBean.isMasterField()) {
        oldValue = formDataMasterBean.getFieldValue(fromFormFieldBean.getName());
        formDataMasterBean.addFieldChanges4Calc(fromFormFieldBean, fieldValue, null, isUpdate);
        formDataMasterBean.addFieldValue(fromFieldName, fieldValue, new FieldDataChangeBO(Integer.valueOf(HistoryDataEnums.FiledChangeType.MANUAL_RELATION.getKey()), formRelationshipMapBean.getRelationshipBean().export4History(null)));
        changeField.put(fromFieldName, fieldValue);
      } else if (formDataBean != null) {
        oldValue = formDataBean.getFieldValue(fromFormFieldBean.getName());
        formDataMasterBean.addFieldChanges4Calc(fromFormFieldBean, fieldValue, formDataSubBean, isUpdate);
        formDataBean.addFieldValue(fromFieldName, fieldValue, new FieldDataChangeBO(Integer.valueOf(HistoryDataEnums.FiledChangeType.MANUAL_RELATION.getKey()), formRelationshipMapBean.getRelationshipBean().export4History(null)));
        changeField.put(formDataBean.generageFillbackKey(fromFieldName), fieldValue);
      } 
      if (oldValue != null && !String.valueOf(oldValue).equals(String.valueOf(fieldValue)) && fromFormFieldBean.isAttachment())
        formDataMasterBean.putSessionAttachments(String.valueOf(oldValue), null); 
    } 
    CAPFormDataLogUtil.recordRelation(formRelationshipMapBean, formDataMasterBean.getId(), changeField);
  }
  
  @ValidateRequestParam(notEmpty = {"relationShipId", "selectDatas"}, validateCacheBeanKey = "fromDataId")
  public ServiceResult<FormCalcResultVO> dealSelectedRelationData(RelationParamBean relationParamBean) throws BusinessException {
    Long fromMasterDataId = relationParamBean.getFormMasterId();
    Map<String, Set<String>> tableName2DeleteIds = new HashMap<>();
    Long fromRightId = Long.valueOf((relationParamBean.getRightId() == null) ? -1L : relationParamBean.getRightId().longValue());
    Map<String, String> selectRecordIds = relationParamBean.getSelectRecordIds();
    Long fromRecordId = relationParamBean.getRecordId();
    FormRelationshipBean formRelationshipBean = this.cap4FormCacheManager.getFormRelationshipBean(relationParamBean.getRelationShipId().longValue());
    if (formRelationshipBean == null || formRelationshipBean.getState() == 0)
      throw businessException(CAPCodeMessageEnum.EXCEPTION.getCode(), ResourceUtil.getString(CAPCodeMessageEnum.EXCEPTION.getMessage()) + "formRelationshipBean is null or state error"); 
    FormDataMasterBean fromFormDataMasterBean = this.cap4FormManager.getSessioMasterDataBean(fromMasterDataId);
    LockObjectBean lockObjectBean = this.capRuntimeDataLockManager.get(fromFormDataMasterBean.getId());
    synchronized (lockObjectBean) {
      List<FormRelationshipMapBean> formRelationshipMapBeans = formRelationshipBean.getRelationMapList();
      if (fromFormDataMasterBean.getRelationRecords() == null)
        fromFormDataMasterBean.setRelationRecords(new ArrayList()); 
      List<CAPFormRelationRecord> capFormRelationRecords = fromFormDataMasterBean.getRelationRecords();
      Long fromFormId = Long.valueOf(formRelationshipBean.getSourceFormId());
      FormBean fromFormBean = this.cap4FormCacheManager.getForm(fromFormId.longValue());
      FormAuthViewBean fromFormAuthViewBean = CAPFormUtil.getFormAuthViewBean(fromFormBean, fromFormDataMasterBean, fromRightId);
      FormViewBean formViewBean = fromFormBean.getFormView(fromFormDataMasterBean.getRuntimeParam().getViewId().longValue());
      List<String> formViewFields = formViewBean.getFieldList();
      try {
        Map<String, String> summaryId2Subject = new HashMap<>();
        Map<String, List<Long>> tableName2AddSubIds = new HashMap<>();
        Set<String> relationUpdateFields4Return = new HashSet<>();
        Map<String, CAPFormRelationRecord> capFormRelationRecordMap = fromFormDataMasterBean.getRelationRecordMap();
        boolean isInsertMulti = false;
        Long insertMultiPreRecordId = null;
        Map<String, Object> relationDataMap = this.cap4FormRelationActionManager.getCacheRelationData(fromFormDataMasterBean.getId());
        if (relationDataMap == null || relationDataMap.isEmpty())
          LOGGER.error(fromFormDataMasterBean.getId() + " dealSelectedRelationData data map is empty! "); 
        FormFieldBean formCalcAutoIncreaseField = null;
        Map<String, Integer> tableAppointPage = new HashMap<>();
        for (Map<String, Object> map : (Iterable<Map<String, Object>>)relationParamBean.getSelectDatas()) {
          boolean isMainSelectField = CAPBusinessEnum.TrueOrFalseEnum.TRUE.getKey().equals(String.valueOf(map.get("isMainSelecter")));
          String selectFieldName = String.valueOf(map.get("fromRelationAttr"));
          FormDataSubBean fromFormDataSubBean = null;
          FormFieldBean fromFormFieldBean = fromFormBean.getFieldBeanByName(selectFieldName);
          formCalcAutoIncreaseField = (formCalcAutoIncreaseField == null && isMainSelectField) ? fromFormFieldBean : null;
          if (fromRecordId != null && fromFormFieldBean.isSubField())
            fromFormDataSubBean = fromFormDataMasterBean.getFormDataSubBeanById(fromFormFieldBean.getOwnerTableName(), fromRecordId); 
          if (fromFormDataSubBean == null && fromFormFieldBean.isSubField() && !isMainSelectField) {
            if (insertMultiPreRecordId == null && selectRecordIds != null && Strings.isNotBlank(selectRecordIds.get(fromFormFieldBean.getOwnerTableName())))
              insertMultiPreRecordId = Long.valueOf(selectRecordIds.get(fromFormFieldBean.getOwnerTableName())); 
            isInsertMulti = true;
            List<FormDataSubBean> subBeans = initRelationAddSubDataBean(fromFormBean, fromFormDataMasterBean, fromFormAuthViewBean, fromFormBean.getTableByTableName(fromFormFieldBean.getOwnerTableName()), insertMultiPreRecordId);
            fromFormDataSubBean = subBeans.get(0);
            insertMultiPreRecordId = fromFormDataSubBean.getId();
          } 
          FormRelationshipMapBean mapBean = this.cap4FormRelationActionManager.getFormRelationshipMapBeanBySelectedFieldName(formRelationshipBean, selectFieldName);
          if (map.get("relationData") == null && relationDataMap != null)
            map.put("relationData", relationDataMap.get(map.get("unique"))); 
          dealRelationData(mapBean, map, fromFormBean, fromFormDataMasterBean, fromFormDataSubBean, summaryId2Subject, !isInsertMulti);
          if (isInsertMulti) {
            if (fromFormDataSubBean == null)
              continue; 
            List<Long> newMultiSubIds = tableName2AddSubIds.get(fromFormFieldBean.getOwnerTableName());
            if (newMultiSubIds == null)
              newMultiSubIds = new ArrayList<>(); 
            newMultiSubIds.add(fromFormDataSubBean.getId());
            CAPFormRelationRecord capFormRelationRecord = convertRelationSelectMap2RelationRecord(fromFormId, fromMasterDataId, fromFormDataSubBean.getId(), mapBean, map);
            capFormRelationRecordMap.put(capFormRelationRecord.getFieldName() + "_" + fromFormDataSubBean.getId(), capFormRelationRecord);
            capFormRelationRecords.add(capFormRelationRecord);
            tableName2AddSubIds.put(fromFormFieldBean.getOwnerTableName(), newMultiSubIds);
          } else {
            if (fromFormFieldBean.isSubField() && fromFormDataSubBean == null)
              continue; 
            Set<String> relationFieldList = mapBean.getFormRelationFieldMap().keySet();
            for (String fieldName : relationFieldList) {
              FormFieldBean formFieldBean = fromFormBean.getFieldBeanByName(fieldName);
              if (formFieldBean != null && formViewFields.contains(fieldName))
                relationUpdateFields4Return.add(formFieldBean.isSubField() ? fromFormDataSubBean.generageFillbackKey(fieldName) : fieldName); 
            } 
            CAPFormRelationRecord oldCapFormRelationRecord = getCAPFormRelationRecordById(capFormRelationRecords, fromFormFieldBean, fromMasterDataId, fromRecordId);
            if (oldCapFormRelationRecord != null) {
              LOGGER.info("删除关联关系记录(session),cause by manual selection," + oldCapFormRelationRecord.exportToMap());
              capFormRelationRecords.remove(oldCapFormRelationRecord);
            } 
            CAPFormRelationRecord capFormRelationRecord = convertRelationSelectMap2RelationRecord(fromFormId, fromMasterDataId, fromRecordId, mapBean, map);
            capFormRelationRecords.add(capFormRelationRecord);
            String recordKey = capFormRelationRecord.getFieldName();
            if (fromFormDataSubBean != null)
              recordKey = recordKey + "_" + fromFormDataSubBean.getId(); 
            capFormRelationRecordMap.put(recordKey, capFormRelationRecord);
          } 
          if (isMainSelectField && !formRelationshipMapBeans.isEmpty()) {
            Integer relationAutoFillSize = PerformanceConfig.getInstance().getIntegerConfig("cap4.relationAutoFillSize");
            for (FormRelationshipMapBean formRelationshipMapBean : formRelationshipMapBeans) {
              FormFieldBean selectFieldBean = fromFormBean.getFieldBeanByName(formRelationshipMapBean.getSelectedField());
              if (formRelationshipMapBean.getAutoFillRepeat() == 1 && !selectFieldBean.isMasterField()) {
                Map<String, Object> queryParams = new HashMap<>();
                queryParams.put("page", "1");
                queryParams.put("pageSize", (relationAutoFillSize == null) ? "100" : String.valueOf(relationAutoFillSize));
                queryParams.put("relationShipId", String.valueOf(relationParamBean.getRelationShipId()));
                queryParams.put("fromRelationAttr", formRelationshipMapBean.getSelectedField());
                queryParams.put("isMainSelecter", CAPBusinessEnum.TrueOrFalseEnum.FALSE.getKey());
                queryParams.put("fromDataId", String.valueOf(fromMasterDataId));
                queryParams.put("fromRecordId", "");
                queryParams.put("selectedMasterDataId", String.valueOf(map.get("dataId")));
                queryParams.put("needShowData", CAPBusinessEnum.TrueOrFalseEnum.FALSE.getKey());
                queryParams.put("cleanCacheRelationData", CAPBusinessEnum.TrueOrFalseEnum.FALSE.getKey());
                Map<String, Object> queryResult = getManualRelationDatas(queryParams, formRelationshipBean, formRelationshipMapBean, 0, formRelationshipMapBean.getSelectedField());
                List<Map<String, Object>> mapList = (List<Map<String, Object>>)queryResult.get("data");
                if (mapList != null && !mapList.isEmpty()) {
                  List<Long> newAutoFillSubIds = new ArrayList<>();
                  FormTableBean fromFormTableBean = fromFormBean.getTableByTableName(selectFieldBean.getOwnerTableName());
                  List<FormDataSubBean> list = new ArrayList<>();
                  fromFormDataMasterBean.setSubData(fromFormTableBean.getTableName(), list);
                  Long autoPreRecordId = (selectRecordIds != null && Strings.isNotBlank(selectRecordIds.get(selectFieldBean.getOwnerTableName()))) ? Long.valueOf(Long.parseLong(selectRecordIds.get(selectFieldBean.getOwnerTableName()))) : null;
                  for (Map<String, Object> tempMap : mapList) {
                    List<FormDataSubBean> subBeans = initRelationAddSubDataBean(fromFormBean, fromFormDataMasterBean, fromFormAuthViewBean, fromFormTableBean, autoPreRecordId);
                    dealRelationData(formRelationshipMapBean, tempMap, fromFormBean, fromFormDataMasterBean, subBeans.get(0), summaryId2Subject, false);
                    Long subId = ((FormDataSubBean)subBeans.get(0)).getId();
                    if (autoPreRecordId != null)
                      autoPreRecordId = subId; 
                    newAutoFillSubIds.add(subId);
                    CAPFormRelationRecord capFormRelationRecord = convertRelationSelectMap2RelationRecord(fromFormId, fromMasterDataId, subId, formRelationshipMapBean, tempMap);
                    capFormRelationRecords.add(capFormRelationRecord);
                    capFormRelationRecordMap.put(capFormRelationRecord.getFieldName() + "_" + subId, capFormRelationRecord);
                  } 
                  tableName2AddSubIds.put(selectFieldBean.getOwnerTableName(), newAutoFillSubIds);
                  PageParamBean pageParamBean = (PageParamBean)relationParamBean.getMergeDataBean().getPageInfo().get(selectFieldBean.getOwnerTableName());
                  if (pageParamBean != null)
                    tableAppointPage.put(selectFieldBean.getOwnerTableName(), Integer.valueOf((autoPreRecordId != null) ? pageParamBean.getPage().intValue() : -1)); 
                } 
              } 
            } 
          } 
        } 
        Map<String, FormTableCalcDataVO> tableName2DataMaps = new HashMap<>();
        Set<String> fillBackFields = new HashSet<>();
        if (!tableName2AddSubIds.isEmpty())
          this.capRuntimeCalcManager.mergeFirstDelete2Result(fromFormDataMasterBean, tableName2DataMaps, tableName2AddSubIds, selectRecordIds, tableName2DeleteIds); 
        resetAppointTablePage(relationParamBean, tableName2AddSubIds.keySet(), tableAppointPage, fromFormDataMasterBean);
        CalcContextBean contextBean = new CalcContextBean(fromFormBean, fromFormAuthViewBean);
        Map<String, List<FormDataSubBean>> fieldTableName2AddSubBeans = calculateAutoIncreaseByField(contextBean, fromFormDataMasterBean, formCalcAutoIncreaseField, fillBackFields, tableName2DeleteIds, false);
        if (fieldTableName2AddSubBeans != null) {
          Map<String, List<Long>> fieldTableName2AddSubIds = CAPFormUtil.getTableName2FormSubDataBeanIds(fieldTableName2AddSubBeans);
          fieldTableName2AddSubIds.forEach((tableName, longs) -> {
                if (tableName2AddSubIds.containsKey(tableName)) {
                  LOGGER.info(fromFormDataMasterBean.getId() + " dealRelationData clear table relation add by field auto increase , " + tableName);
                  tableName2AddSubIds.remove(tableName);
                } else {
                  LOGGER.info(fromFormDataMasterBean.getId() + " dealRelationData table data add by field auto increase , " + tableName);
                } 
                tableAppointPage.put(tableName, Integer.valueOf(1));
              });
          tableName2AddSubIds.putAll(fieldTableName2AddSubIds);
        } 
        AutoRelationTipBean autoRelationTipBean = contextBean.getAutoRelationTipBean();
        contextBean = new CalcContextBean(fromFormBean, fromFormAuthViewBean);
        contextBean.setAutoRelationTipBean(autoRelationTipBean);
        fillBackFields.addAll(this.capRuntimeCalcManager.execCalcAll(contextBean, fromFormDataMasterBean, tableName2AddSubIds));
        fillBackFields.addAll(relationUpdateFields4Return);
        this.capRuntimeCalcManager.buildCalcAllResult(fromFormBean, fromFormDataMasterBean, fromFormAuthViewBean, tableName2AddSubIds, fillBackFields, CAPBusinessEnum.SubBeanNewFrom.MANUAL_RELATION, tableName2DataMaps);
        if (!tableName2DeleteIds.isEmpty())
          mergeAutoDelete2Result(tableName2DeleteIds, tableName2DataMaps); 
        tableName2AddSubIds.forEach((k, v) -> {
              if (!tableAppointPage.containsKey(k))
                tableAppointPage.put(k, Integer.valueOf(-1)); 
            });
        this.capRuntimeCalcManager.fillTablePageData(fromFormBean, fromFormDataMasterBean, fromFormAuthViewBean, relationParamBean.getMergeDataBean().getPageInfo(), tableName2DataMaps, tableName2AddSubIds
            .keySet(), tableAppointPage);
        FormCalcResultVO resultData = new FormCalcResultVO(tableName2DataMaps);
        ServiceResult<FormCalcResultVO> result = (new ServiceResult.ServiceResultBuilder()).success().data(resultData).build();
        HandlerFactory.buildResultHandler(contextBean, fromFormDataMasterBean, result);
        this.cap4FormManager.putMasterDataBean2Cache(fromFormDataMasterBean.getId(), fromFormDataMasterBean);
        return result;
      } catch (Exception e) {
        LOGGER.error("method dealSelectedRelationData is error." + e.getMessage(), e);
        throw businessException(CAPCodeMessageEnum.EXCEPTION.getCode(), ResourceUtil.getString(CAPCodeMessageEnum.EXCEPTION.getMessage()) + e.getMessage());
      } finally {
        this.cap4FormRelationActionManager.removeCacheRelationData(fromFormDataMasterBean.getId());
      } 
    } 
  }
  
  private void resetAppointTablePage(RelationParamBean relationParamBean, Set<String> tableNames, Map<String, Integer> table2Page, FormDataMasterBean formDataMasterBean) {
    tableNames.forEach(tableName -> {
          if (table2Page.containsKey(tableName))
            return; 
          String preRecordId = (relationParamBean.getSelectRecordIds() == null) ? null : (String)relationParamBean.getSelectRecordIds().get(tableName);
          PageParamBean pageParamBean = (PageParamBean)relationParamBean.getMergeDataBean().getPageInfo().get(tableName);
          if (StringUtils.isNotBlank(preRecordId) && pageParamBean != null) {
            List<FormDataSubBean> subData = formDataMasterBean.getSubData(tableName);
            int originalPagePosition = this.capRuntimeCalcManager.getOriginalPagePosition(subData, Long.valueOf(Long.parseLong(preRecordId)), pageParamBean.getSize().intValue());
            table2Page.put(tableName, Integer.valueOf(originalPagePosition));
          } 
        });
  }
  
  @ValidateRequestParam(notEmpty = {"relationShipId", "rightId", "fromRelationAttr"}, validateCacheBeanKey = "formMasterDataId")
  public ServiceResult cleanRelationData(RelationParamBean relationParamBean) throws BusinessException {
    Long fromMasterDataId = relationParamBean.getFormMasterId();
    FormDataMasterBean cacheFormDataMasterBean = this.cap4FormManager.getSessioMasterDataBean(fromMasterDataId);
    if (relationParamBean.getMergeDataBean() != null)
      mergeFormData(cacheFormDataMasterBean, relationParamBean.getMergeDataBean()); 
    Long relationShipId = relationParamBean.getRelationShipId();
    Long fromRightId = relationParamBean.getRightId();
    Long fromRecordId = relationParamBean.getRecordId();
    String fromRelationAttr = relationParamBean.getFromRelationAttr();
    FormRelationshipBean formRelationshipBean = this.cap4FormCacheManager.getFormRelationshipBean(relationShipId.longValue());
    if (formRelationshipBean == null || formRelationshipBean.getState() == 0)
      throw businessException(CAPCodeMessageEnum.EXCEPTION.getCode(), ResourceUtil.getString(CAPCodeMessageEnum.EXCEPTION.getMessage()) + "formRelationshipBean is null or state error"); 
    try {
      FormRelationshipMapBean formRelationshipMapBean = this.cap4FormRelationActionManager.getFormRelationshipMapBeanBySelectedFieldName(formRelationshipBean, fromRelationAttr);
      FormBean formBean = this.cap4FormCacheManager.getForm(formRelationshipBean.getSourceFormId());
      FormFieldBean fieldBean = formBean.getFieldBeanByName(fromRelationAttr);
      FormDataSubBean formDataSubBean = null;
      if (fieldBean.isSubField()) {
        if (fromRecordId == null)
          throw businessException(CAPCodeMessageEnum.EXCEPTION.getCode(), ResourceUtil.getString(CAPCodeMessageEnum.EXCEPTION.getMessage()) + "fromRecordId is null"); 
        formDataSubBean = cacheFormDataMasterBean.getFormDataSubBeanById(fieldBean.getOwnerTableName(), fromRecordId);
        if (formDataSubBean == null)
          throw businessException(CAPCodeMessageEnum.EXCEPTION.getCode(), ResourceUtil.getString(CAPCodeMessageEnum.EXCEPTION.getMessage()) + "formDataSubBean is null"); 
      } 
      FormAuthViewBean fromFormAuthViewBean = CAPFormUtil.getFormAuthViewBean(formBean, cacheFormDataMasterBean, fromRightId);
      FormViewBean formViewBean = formBean.getFormView(cacheFormDataMasterBean.getRuntimeParam().getViewId().longValue());
      List<String> formViewFields = formViewBean.getFieldList();
      Map<String, String> fieldMap = formRelationshipMapBean.getFormRelationFieldMap();
      Iterator<String> iterator = fieldMap.keySet().iterator();
      Set<String> relationCleanFields4Return = new HashSet<>();
      while (iterator.hasNext()) {
        String key = iterator.next();
        FormFieldBean formFieldBean = formBean.getFieldBeanByName(key);
        if (formFieldBean.isAttachment()) {
          Object oldValue = (formDataSubBean == null) ? cacheFormDataMasterBean.getFieldValue(formFieldBean.getName()) : formDataSubBean.getFieldValue(formFieldBean.getName());
          if (oldValue != null)
            cacheFormDataMasterBean.putSessionAttachments(String.valueOf(oldValue), null); 
        } 
        cacheFormDataMasterBean.addFieldChanges4Calc(formFieldBean, null, formDataSubBean, true);
        if (formDataSubBean == null) {
          cacheFormDataMasterBean.addFieldValue(key, null, new FieldDataChangeBO(Integer.valueOf(HistoryDataEnums.FiledChangeType.MANUAL_RELATION.getKey()), formRelationshipBean.export4History("clear")));
        } else {
          formDataSubBean.addFieldValue(key, null, new FieldDataChangeBO(Integer.valueOf(HistoryDataEnums.FiledChangeType.MANUAL_RELATION.getKey()), formRelationshipBean.export4History("clear")));
        } 
        if (formViewFields.contains(formFieldBean.getName()))
          relationCleanFields4Return.add((formDataSubBean != null) ? formDataSubBean.generageFillbackKey(formFieldBean.getName()) : formFieldBean.getName()); 
      } 
      LOGGER.info(cacheFormDataMasterBean.getId() + " clear manual relation " + formRelationshipMapBean.export4Log() + ", fields " + fieldMap.keySet().toString());
      if (cacheFormDataMasterBean.getRelationRecords() != null) {
        CAPFormRelationRecord capFormRelationRecord = getCAPFormRelationRecordById(cacheFormDataMasterBean.getRelationRecords(), fieldBean, fromMasterDataId, fromRecordId);
        if (capFormRelationRecord != null) {
          LOGGER.info("删除关联关系记录(session),cause by cleanRelationData," + capFormRelationRecord.exportToMap());
          cacheFormDataMasterBean.getRelationRecords().remove(capFormRelationRecord);
        } 
      } 
      Map<String, CAPFormRelationRecord> capFormRelationRecordMap = cacheFormDataMasterBean.getRelationRecordMap();
      capFormRelationRecordMap.remove((formDataSubBean == null) ? fieldBean.getName() : formDataSubBean.generageFillbackKey(fieldBean.getName()));
      Map<String, FormTableCalcDataVO> tableName2DataMaps = new HashMap<>();
      Set<String> fillBackFields = new HashSet<>();
      Map<String, List<FormDataSubBean>> fieldTableName2AddSubBeans = null;
      Map<String, Set<String>> tableName2DeleteIds = new HashMap<>();
      Map<String, List<Long>> tableName2AddSubIds = new HashMap<>();
      Map<String, Integer> tableAppointPage = new HashMap<>();
      CalcContextBean contextBean = new CalcContextBean(formBean, fromFormAuthViewBean);
      if (fieldBean.isMasterField()) {
        fieldTableName2AddSubBeans = calculateAutoIncreaseByField(contextBean, cacheFormDataMasterBean, fieldBean, fillBackFields, tableName2DeleteIds, false);
        if (fieldTableName2AddSubBeans != null) {
          Map<String, List<Long>> fieldTableName2AddSubIds = CAPFormUtil.getTableName2FormSubDataBeanIds(fieldTableName2AddSubBeans);
          fieldTableName2AddSubIds.forEach((s, longs) -> tableAppointPage.put(s, Integer.valueOf(1)));
          tableName2AddSubIds.putAll(fieldTableName2AddSubIds);
        } 
        LOGGER.info(cacheFormDataMasterBean.getId() + " clear manual relation " + fieldBean.getName() + " trigger new line details " + ((fieldTableName2AddSubBeans == null) ? null : fieldTableName2AddSubBeans.keySet().toString()));
      } 
      AutoRelationTipBean autoRelationTipBean = contextBean.getAutoRelationTipBean();
      contextBean = new CalcContextBean(formBean, fromFormAuthViewBean);
      contextBean.setAutoRelationTipBean(autoRelationTipBean);
      fillBackFields.addAll(this.capRuntimeCalcManager.execCalcAll(contextBean, cacheFormDataMasterBean, tableName2AddSubIds));
      fillBackFields.addAll(relationCleanFields4Return);
      this.capRuntimeCalcManager.buildCalcAllResult(formBean, cacheFormDataMasterBean, fromFormAuthViewBean, tableName2AddSubIds, fillBackFields, CAPBusinessEnum.SubBeanNewFrom.MANUAL_RELATION, tableName2DataMaps);
      if (!tableName2DeleteIds.isEmpty())
        mergeAutoDelete2Result(tableName2DeleteIds, tableName2DataMaps); 
      this.capRuntimeCalcManager.fillTablePageData(formBean, cacheFormDataMasterBean, fromFormAuthViewBean, relationParamBean.getMergeDataBean().getPageInfo(), tableName2DataMaps, tableName2AddSubIds
          .keySet(), tableAppointPage);
      FormCalcResultVO resultData = new FormCalcResultVO(tableName2DataMaps);
      ServiceResult<FormCalcResultVO> result = (new ServiceResult.ServiceResultBuilder()).success().data(resultData).build();
      HandlerFactory.buildResultHandler(contextBean, cacheFormDataMasterBean, result);
      this.cap4FormManager.putMasterDataBean2Cache(cacheFormDataMasterBean.getId(), cacheFormDataMasterBean);
      return result;
    } catch (BusinessException e) {
      LOGGER.error("method cleanRelationData is error." + e.getMessage(), (Throwable)e);
      throw businessException(CAPCodeMessageEnum.EXCEPTION.getCode(), ResourceUtil.getString(CAPCodeMessageEnum.EXCEPTION.getMessage()) + e.getMessage());
    } 
  }
  
  private List<FormDataSubBean> initRelationAddSubDataBean(FormBean formBean, FormDataMasterBean formDataMasterBean, FormAuthViewBean formAuthViewBean, FormTableBean formTableBean, Long preRecordId) throws BusinessException {
    List<FormDataSubBean> newFormDataSubBeans = new ArrayList<>();
    FormDataSubBean formDataSubBean = new FormDataSubBean(formTableBean, formDataMasterBean, new boolean[] { true });
    formDataSubBean.setFormmainId(formDataMasterBean.getId().longValue());
    newFormDataSubBeans.add(formDataSubBean);
    if (preRecordId != null) {
      formDataMasterBean.addSubData(formTableBean.getTableName(), formDataSubBean, preRecordId);
    } else {
      formDataMasterBean.addSubData(formTableBean.getTableName(), formDataSubBean);
    } 
    return this.capRuntimeManager.procNewBeanDefaultValue(formBean, formDataMasterBean, formAuthViewBean, formTableBean, newFormDataSubBeans);
  }
  
  private CAPFormRelationRecord convertRelationSelectMap2RelationRecord(Long fromFormId, Long fromMasterDataId, Long fromSubDataId, FormRelationshipMapBean relationshipMapBean, Map<String, Object> relationRecord) throws BusinessException {
    CAPFormRelationRecord record = new CAPFormRelationRecord();
    record.setNewId();
    record.setMemberId(Long.valueOf(AppContext.currentUserId()));
    record.setFromMasterDataId(fromMasterDataId);
    record.setFromSubdataId(fromSubDataId);
    record.setFromFormId(fromFormId);
    record.setType(Integer.valueOf(FormRelationEnums.ViewSelectType.user.getKey()));
    record.setFormType(Integer.valueOf(Integer.parseInt((String)relationRecord.get("toFormType"))));
    record.setFieldName((String)relationRecord.get("fromRelationAttr"));
    record.setToFormId(Long.valueOf((String)relationRecord.get("toFormId")));
    record.setToMasterDataId(Long.valueOf((String)relationRecord.get("dataId")));
    record.setToSubdataId(Strings.isBlank((String)relationRecord.get("subDataId")) ? null : Long.valueOf((String)relationRecord.get("subDataId")));
    record.setDataInfo(relationshipMapBean, (fieldName, mapBean) -> CAPFormUtil.getManualRelationViewRightId(mapBean));
    return record;
  }
  
  private CAPFormRelationRecord getCAPFormRelationRecordById(List<CAPFormRelationRecord> capFormRelationRecords, FormFieldBean fromFormFieldBean, Long fromMasterId, Long fromSubId) {
    for (CAPFormRelationRecord capFormRelationRecord : capFormRelationRecords) {
      Long fromMasterDataId = capFormRelationRecord.getFromMasterDataId();
      Long fromSubDataId = capFormRelationRecord.getFromSubdataId();
      String fromFieldName = capFormRelationRecord.getFieldName();
      if (fromMasterDataId.longValue() == fromMasterId.longValue() && fromFormFieldBean.getName().equals(fromFieldName) && ((
        fromSubId == null && fromSubDataId == null) || (fromSubId != null && fromSubDataId != null && fromSubId.longValue() == fromSubDataId.longValue())))
        return capFormRelationRecord; 
    } 
    return null;
  }
  
  @ValidateRequestParam(notEmpty = {"relationShipId", "fromRelationAttr"})
  public Map<String, Object> getFormRelationDatas(Map<String, Object> params) throws BusinessException {
    Map<String, Object> result = new HashMap<>();
    if (params.get("mergeData") != null) {
      MergeDataParamBean mergeDataBean = MergeDataParamBean.newInstance((Map)params.get("mergeData"));
      Map<String, Object> content = mergeDataBean.getContent();
      if (content == null) {
        result.put("code", "2004");
        result.put("message", String.format(ResourceUtil.getString("cap.template.message.paramNull"), new Object[] { "content" }));
        return result;
      } 
      Long formMasterDataId = Long.valueOf((String)content.get("contentDataId"));
      FormDataMasterBean cacheFormDataMasterBean = this.cap4FormManager.getSessioMasterDataBean(formMasterDataId);
      if (cacheFormDataMasterBean == null) {
        result.put("code", "2010");
        result.put("message", ResourceUtil.getString("cap.template.form.data.message.cacheDisabled"));
        LOGGER.info("缓存失效！" + content + " , user " + AppContext.currentUserName());
        return result;
      } 
      mergeFormData(cacheFormDataMasterBean, mergeDataBean);
    } 
    Long relationShipId = CAPParamUtil.getLong(params, "relationShipId");
    String fromRelationAttr = CAPParamUtil.getString(params, "fromRelationAttr");
    int isMainSelecter = CAPParamUtil.getIntValue(params, "isMainSelecter").intValue();
    Integer pageSize = CAPParamUtil.getInteger(params, "pageSize");
    pageSize = (pageSize == null) ? PerformanceConfig.getInstance().getIntegerConfig("paginate.page.size") : pageSize;
    params.put("pageSize", Integer.valueOf((pageSize == null) ? 50 : pageSize.intValue()));
    FormRelationshipBean formRelationshipBean = this.cap4FormCacheManager.getFormRelationshipBean(relationShipId.longValue());
    if (formRelationshipBean == null || formRelationshipBean.getState() == 0) {
      result.put("code", "2013");
      result.put("message", ResourceUtil.getString("cap.template.relation.ship.disabled"));
      return result;
    } 
    FormRelationshipMapBean mainSelecterBean = formRelationshipBean.getMainSelector();
    FormRelationshipMapBean formRelationshipMapBean = null;
    if (isMainSelecter == 1) {
      formRelationshipMapBean = mainSelecterBean;
    } else {
      formRelationshipMapBean = this.cap4FormRelationActionManager.getFormRelationshipMapBeanBySelectedFieldName(formRelationshipBean, fromRelationAttr);
    } 
    params.put("cleanCacheRelationData", CAPBusinessEnum.TrueOrFalseEnum.TRUE.getKey());
    try {
      result = getManualRelationDatas(params, formRelationshipBean, formRelationshipMapBean, isMainSelecter, fromRelationAttr);
      List<FilterFieldVO> filterFields = (List<FilterFieldVO>)result.get("filterFields");
      if (CollectionUtils.isNotEmpty(filterFields)) {
        Set<String> fieldKeys = Sets.newHashSet();
        for (FilterFieldVO map : filterFields) {
          if (FormFieldComEnum.SELECT.getKey().equals(map.getInputType()) || FormFieldComEnum.RADIO
            .getKey().equals(map.getInputType()) || FormFieldComEnum.IMAGE_SELECT
            .getKey().equals(map.getInputType()) || FormFieldComEnum.IMAGE_RADIO
            .getKey().equals(map.getInputType()) || FormFieldComEnum.MULTI_SELECT
            .getKey().equals(map.getInputType()))
            fieldKeys.add(map.getName()); 
        } 
        for (FilterFieldVO map : filterFields) {
          String toRelationAttr = map.getToRelationAttr();
          if (toRelationAttr != null) {
            if (fieldKeys.contains(toRelationAttr)) {
              map.setMultiEnum(CAPBusinessEnum.TrueOrFalseEnum.TRUE.getKey());
              map.setParentField(map.getAliasTableName() + "_" + toRelationAttr);
              continue;
            } 
            map.setMultiEnum(CAPBusinessEnum.TrueOrFalseEnum.FALSE.getKey());
            continue;
          } 
          map.setMultiEnum(CAPBusinessEnum.TrueOrFalseEnum.FALSE.getKey());
        } 
      } 
    } catch (BusinessException e) {
      LOGGER.error("getFormRelationDatas is error . param is " + params.toString(), (Throwable)e);
      result.put("code", "2001");
      result.put("message", e.getMessage());
    } 
    return result;
  }
  
  private Map<String, Object> getManualRelationDatas(Map<String, Object> params, FormRelationshipBean formRelationshipBean, FormRelationshipMapBean formRelationshipMapBean, int isMainSelecter, String fromRelationAttr) throws BusinessException {
    Map<String, Object> result = new HashMap<>();
    Integer isInit = CAPParamUtil.getInteger(params, "isInit");
    isInit = Integer.valueOf((isInit == null) ? 0 : isInit.intValue());
    FormBean fb = this.cap4FormCacheManager.getForm(formRelationshipBean.getTargetFormId());
    if (fb == null && this.cap4FormRelationActionManager.isMagicRelation(formRelationshipBean)) {
      ICAP4MagicExecuteManager cap4MagicExecuteManager = (ICAP4MagicExecuteManager)AppContext.getBean("cap4MagicExecuteManager");
      result = cap4MagicExecuteManager.getFormRelationDatasByMagic(params, formRelationshipBean, formRelationshipMapBean);
    } else {
      Integer page = CAPParamUtil.getInteger(params, "page");
      Integer pageSize = CAPParamUtil.getInteger(params, "pageSize");
      List<Map<String, Object>> conditions = (params.get("conditions") != null) ? (List<Map<String, Object>>)params.get("conditions") : null;
      page = Integer.valueOf((page == null) ? 1 : page.intValue());
      pageSize = Integer.valueOf((pageSize == null) ? 50 : pageSize.intValue());
      Long fromDataId = CAPParamUtil.getLong(params, "fromDataId");
      Long fromRecordId = CAPParamUtil.getLong(params, "fromRecordId");
      Boolean isTree = MapUtils.getBoolean(params, "isTree", Boolean.valueOf(false));
      FlipInfo flipInfo = new FlipInfo(page.intValue());
      flipInfo.setSize(pageSize.intValue());
      FormBean toFormBean = this.cap4FormCacheManager.getForm(formRelationshipBean.getTargetFormId());
      CAP4RelationQueryParamsBO cap4RelationQueryParamsBO = new CAP4RelationQueryParamsBO();
      if (isMainSelecter != 1) {
        Long selectedMasterDataId = CAPParamUtil.getLong(params, "selectedMasterDataId");
        if (selectedMasterDataId != null)
          if (Enums.FormType.processesForm.getKey() == toFormBean.getFormType()) {
            ColSummary colSummary = this.collaborationApi.getColSummary(selectedMasterDataId);
            cap4RelationQueryParamsBO.setSelectedToMasterDataId(colSummary.getFormRecordid());
          } else {
            cap4RelationQueryParamsBO.setSelectedToMasterDataId(selectedMasterDataId);
          }  
      } 
      cap4RelationQueryParamsBO.setFromFormId(Long.valueOf(formRelationshipBean.getSourceFormId()));
      cap4RelationQueryParamsBO.setFromDataId(fromDataId);
      cap4RelationQueryParamsBO.setFromRecordId(fromRecordId);
      cap4RelationQueryParamsBO.setFromRelationAttr(fromRelationAttr);
      cap4RelationQueryParamsBO.setFormRelationshipMapBean(formRelationshipMapBean);
      cap4RelationQueryParamsBO.setTree(isTree.booleanValue());
      if (isInit.intValue() == 1)
        getInitData(formRelationshipMapBean, toFormBean, result, conditions, fromDataId, fromRecordId); 
      result.put("data", getCAPManualRelationDataList(toFormBean, formRelationshipMapBean, cap4RelationQueryParamsBO, conditions, flipInfo, fromRelationAttr, isMainSelecter));
      if (isTree.booleanValue()) {
        CAPDataRelationParamBean capDataRelationParamBean = new CAPDataRelationParamBean(flipInfo, cap4RelationQueryParamsBO, conditions);
        DataRelationTreeParamResult dataRelationTreeParamResult = HookUtil.execute(CAPFormRelationParmaHook.class, null, (AbstractHookParamBean)capDataRelationParamBean).stream().map(treeParam -> (DataRelationTreeParamResult)treeParam).findFirst().orElse(null);
        if (Objects.nonNull(dataRelationTreeParamResult)) {
          result.put("loadType", String.valueOf(dataRelationTreeParamResult.getLoadType()));
          result.put("numLimit", dataRelationTreeParamResult.getNumLimit());
          result.put("foldingType", String.valueOf(dataRelationTreeParamResult.getFoldingType()));
          if (isInit.intValue() == 1) {
            List<Map<String, String>> columnFields = (List<Map<String, String>>)result.get("columnFields");
            for (Map<String, String> columnField : columnFields) {
              if (Objects.equals(columnField.get("field"), dataRelationTreeParamResult.getTaskNameField())) {
                columnField.put("dataType", "tree");
                break;
              } 
            } 
          } 
        } 
      } 
      getCAPManualRelationOtherResult(result, formRelationshipMapBean, flipInfo, toFormBean);
      result.put("code", "2000");
    } 
    if ("2000".equals(result.get("code")) && CAPBusinessEnum.TrueOrFalseEnum.TRUE.getKey().equals(params.get("cleanCacheRelationData"))) {
      Long masterId = CAPParamUtil.getLong(params, "fromDataId");
      List<Map<String, Object>> list = (List<Map<String, Object>>)result.get("data");
      if (Strings.isNotEmpty(list)) {
        Map<String, Object> relationDataMap = new HashMap<>();
        Map<String, Object> exitsMap = this.cap4FormRelationActionManager.getCacheRelationData(masterId);
        if (exitsMap != null)
          relationDataMap.putAll(exitsMap); 
        for (Map<String, Object> map : list) {
          relationDataMap.put(String.valueOf(map.get("unique")), map.get("relationData"));
          map.remove("relationData");
        } 
        this.cap4FormRelationActionManager.addCacheRelationData(masterId, relationDataMap);
      } 
    } 
    return result;
  }
  
  private void getInitData(FormRelationshipMapBean formRelationshipMapBean, FormBean toFormBean, Map<String, Object> result, List<Map<String, Object>> conditions, Long fromDataId, Long fromRecordId) throws BusinessException {
    List<SimpleObjectBean> searchFields = formRelationshipMapBean.getQueryFieldList();
    if (Strings.isEmpty(searchFields)) {
      List<SimpleObjectBean> showFields = formRelationshipMapBean.getShowFieldList();
      if (showFields.size() > 3) {
        searchFields = showFields.subList(0, 3);
      } else {
        searchFields = showFields;
      } 
    } 
    List<FilterFieldBean> filterFieldBeanList = this.capFilterFieldManager.getFilterFieldBeans(toFormBean, searchFields, FormQueryTypeEnum.relationFormQuery);
    List<FilterFieldVO> filterFields = this.capFilterFieldManager.getFilterFields(filterFieldBeanList);
    CAPRelationSelectConditionBean capRelationSelectConditionBean = new CAPRelationSelectConditionBean(conditions, filterFields, formRelationshipMapBean.getId(), fromRecordId);
    HookUtil.execute(CAPRelationSelectConditionHook.class, new DataHookContextBean(toFormBean, null, this.cap4FormManager
          
          .getSessioMasterDataBean(fromDataId)), (AbstractHookParamBean)capRelationSelectConditionBean);
    conditions = capRelationSelectConditionBean.getConditions();
    result.put("filterFields", capRelationSelectConditionBean.getFilterFields());
    List<Map<String, Object>> list = new ArrayList<>(formRelationshipMapBean.getShowFieldList().size());
    for (SimpleObjectBean simpleObjectBean : formRelationshipMapBean.getShowFieldList()) {
      FormFieldBean fieldBean = toFormBean.getFieldBeanByName(simpleObjectBean.getName());
      if (fieldBean == null)
        continue; 
      Map<String, Object> dataMap = new HashMap<>(16);
      if (simpleObjectBean.getValue() != null && simpleObjectBean.getValue().contains("(")) {
        dataMap.put("title", simpleObjectBean.getValue().substring(simpleObjectBean.getValue().indexOf("(") + 1, simpleObjectBean.getValue().indexOf(")")));
      } else {
        dataMap.put("title", simpleObjectBean.getValue());
      } 
      dataMap.put("field", simpleObjectBean.getName());
      dataMap.put("fieldType", fieldBean.getFieldType());
      dataMap.put("inputType", fieldBean.getInputType());
      dataMap.put("customCtl", Boolean.valueOf(fieldBean.isCustomerCtrl()));
      if (fieldBean.isCustomerCtrl()) {
        FormFieldCtrl fieldCtrl = fieldBean.getFieldCtrl();
        if (fieldCtrl != null) {
          FormFieldCustomCtrl ctrl = (FormFieldCustomCtrl)fieldCtrl;
          CustomCtlBean customCtlBean = new CustomCtlBean();
          customCtlBean.setCustomFieldKey(ctrl.getKey());
          FormFieldCustomCtrlRunInfo renderInfo4Run = ctrl.getRenderInfo4Run();
          FormFieldCustomCtrlReportInfo formFieldCustomCtrlReportInfo = ctrl.canShowInReport();
          if (formFieldCustomCtrlReportInfo != null)
            BeanUtils.copyProperties(formFieldCustomCtrlReportInfo, customCtlBean); 
          customCtlBean.setCustomFieldRunInfo(renderInfo4Run);
          customCtlBean.setConfigPath(ctrl.viewJsUrl());
          dataMap.put("properties", customCtlBean);
        } 
      } 
      list.add(dataMap);
    } 
    result.put("columnFields", list);
  }
  
  private void getCAPManualRelationOtherResult(Map<String, Object> result, FormRelationshipMapBean formRelationshipMapBean, FlipInfo flipInfo, FormBean toFormBean) {
    String pcRightId = "";
    String phoneRightId = "";
    if (formRelationshipMapBean.getListThrough() == 1) {
      if (!Strings.isBlank(formRelationshipMapBean.getListPcView()))
        pcRightId = formRelationshipMapBean.getListPcView(); 
      if (!Strings.isBlank(formRelationshipMapBean.getListPhoneView()))
        phoneRightId = formRelationshipMapBean.getListPhoneView(); 
    } 
    result.put("pcRightId", pcRightId);
    result.put("phoneRightId", phoneRightId);
    result.put("page", String.valueOf(flipInfo.getPage()));
    result.put("pageSize", String.valueOf(flipInfo.getSize()));
    result.put("dataCount", String.valueOf(flipInfo.getDataCount()));
    result.put("total", String.valueOf(flipInfo.getTotal()));
    result.put("toFormId", String.valueOf(toFormBean.getId()));
    if (Enums.FormType.unFlowForm.getKey() == toFormBean.getFormType()) {
      result.put("toFormType", ModuleType.cap4UnflowForm.getValue());
    } else if (Enums.FormType.processesForm.getKey() == toFormBean.getFormType()) {
      result.put("toFormType", ModuleType.collaboration.getValue());
    } 
    result.put("toVersion", formRelationshipMapBean.getRelationshipBean().getTargetFormVersion());
    result.put("viewConditionId", (formRelationshipMapBean.getListConditionViewId() == null) ? "" : String.valueOf(formRelationshipMapBean.getListConditionViewId()));
    this.cap4FormRelationActionManager.addRelationThroughUnFlowRight(formRelationshipMapBean, "list");
  }
  
  private List<Map<String, Object>> getCAPManualRelationDataList(FormBean toFormBean, FormRelationshipMapBean formRelationshipMapBean, CAP4RelationQueryParamsBO cap4RelationQueryParamsBO, List<Map<String, Object>> conditions, FlipInfo flipInfo, String fromRelationAttr, int isMainSelecter) throws BusinessException {
    List<Map<String, Object>> contents = new ArrayList<>();
    FormBean fromFormBean = this.cap4FormCacheManager.getForm(formRelationshipMapBean.getRelationshipBean().getSourceFormId());
    Map<String, String> relationFieldMap = formRelationshipMapBean.getFormRelationFieldMap();
    String toRelationAttr = relationFieldMap.get(fromRelationAttr);
    FormFieldBean toRelationFieldBean = toFormBean.getFieldBeanByName(toRelationAttr);
    boolean isRelMasterTable = (toRelationFieldBean == null) ? true : toRelationFieldBean.isMasterField();
    conditions = FormSearchUtil.getUserConditions(toFormBean, conditions);
    boolean isTree = cap4RelationQueryParamsBO.isTree();
    boolean hasTreeResult = false;
    if (isTree) {
      CAPDataRelationParamBean capDataRelationParamBean = new CAPDataRelationParamBean(flipInfo, cap4RelationQueryParamsBO, conditions);
      hasTreeResult = ((Boolean)HookUtil.execute(CAPFormRelationDataHook.class, null, (AbstractHookParamBean)capDataRelationParamBean).stream().map(result -> (DataRelationDataResult)result).findFirst().map(DataRelationDataResult::getResult).orElse(Boolean.valueOf(false))).booleanValue();
    } 
    if (!hasTreeResult)
      if (isRelMasterTable) {
        this.cap4FormRelationActionManager.getFormRelationDataList(flipInfo, cap4RelationQueryParamsBO, conditions);
      } else {
        this.cap4FormRelationActionManager.getFormRelationSubDataList(flipInfo, cap4RelationQueryParamsBO, conditions);
      }  
    List<Map> relationDatas = flipInfo.getData();
    List<String> mergeFieldList = this.cap4FormRelationActionManager.getRelationQueryFields(formRelationshipMapBean);
    List<String> showFieldList = new ArrayList<>();
    Map<String, Object> fieldNameToShowValue = new HashMap<>();
    for (SimpleObjectBean temp : formRelationshipMapBean.getShowFieldList()) {
      showFieldList.add(temp.getName());
      FormFieldBean formFieldBean = toFormBean.getFieldBeanByName(temp.getName());
      if (temp.getValue() != null && temp.getValue().indexOf("(") > -1) {
        fieldNameToShowValue.put(temp.getName(), temp.getValue().substring(temp.getValue().indexOf("(") + 1, temp.getValue().indexOf(")")));
        continue;
      } 
      fieldNameToShowValue.put(temp.getName(), formFieldBean.getDisplay());
    } 
    Set<Long> masterDataIdSets = new HashSet<>();
    for (int i = 0; i < relationDatas.size(); i++) {
      Map relationData = relationDatas.get(i);
      String dataId = String.valueOf(relationData.get(Enums.SubTableField.formmain_id.getKey()));
      if (Strings.isNotBlank(dataId))
        masterDataIdSets.add(Long.valueOf(dataId)); 
    } 
    Map<Long, Long> masterDataId2SummeryId = this.cap4FormRelationActionManager.getMasterIdToModuleIdAndAddRight(toFormBean.getFormType(), masterDataIdSets, (formRelationshipMapBean.getListThrough() == 1 || formRelationshipMapBean.getViewThrough() == 1));
    for (int j = 0; j < relationDatas.size(); j++) {
      String unique;
      Map relationData = relationDatas.get(j);
      String dataId = String.valueOf(relationData.get(Enums.SubTableField.formmain_id.getKey()));
      String id = String.valueOf(relationData.get("id"));
      if (dataId.equals(id)) {
        if (relationData.get("formson_id") == null) {
          unique = dataId;
        } else {
          unique = dataId + "_" + relationData.get("formson_id");
        } 
      } else {
        unique = dataId + "_" + id;
      } 
      Map<String, Object> content = new HashMap<>();
      content.put("unique", unique);
      Map<String, Object> mergeRecordData = new HashMap<>();
      for (int k = 0; k < mergeFieldList.size(); k++) {
        String rShowField = mergeFieldList.get(k);
        FormFieldBean toFormFieldBean = toFormBean.getFieldBeanByName(rShowField);
        Map<String, Object> toContentValue = new HashMap<>();
        toContentValue.putAll(CAPCommonUtil.getDisplayValueMap(relationData.get(rShowField), toFormFieldBean, null));
        String display = (String)fieldNameToShowValue.get(toFormFieldBean.getName());
        toContentValue.put("display", (display != null) ? display : toFormFieldBean.getDisplay());
        toContentValue.put("isAttach", toFormFieldBean.isAttachment() ? "1" : "0");
        mergeRecordData.put(rShowField, toContentValue);
      } 
      Map<String, Object> fromKeyDatas = new HashMap<>();
      Iterator<E> iteratorField = relationFieldMap.keySet().iterator();
      while (iteratorField.hasNext()) {
        String key = iteratorField.next().toString();
        if (FormRelationEnums.SpecialRelationItem.FLOW_NAME.getKey().equals(relationFieldMap.get(key)))
          continue; 
        Map<String, Object> tempData = (HashMap)mergeRecordData.get(relationFieldMap.get(key));
        Map<String, Object> newData = new HashMap<>();
        FormFieldBean fromFieldBean = fromFormBean.getFieldBeanByName(key);
        newData.put("tableName", fromFieldBean.getOwnerTableName());
        newData.put("value", tempData.get("value"));
        newData.put("showValue", tempData.get("showValue"));
        newData.put("showValue2", tempData.get("showValue2"));
        fromKeyDatas.put(key, newData);
      } 
      content.put("showData", mergeRecordData);
      content.put("showDataList", showFieldList);
      content.put("relationData", fromKeyDatas);
      content.put("masterId", dataId);
      content.put("isMainSelecter", String.valueOf(isMainSelecter));
      content.put("toFormId", String.valueOf(toFormBean.getId()));
      if (Enums.FormType.unFlowForm.getKey() == toFormBean.getFormType()) {
        content.put("toFormType", ModuleType.cap4UnflowForm.getValue());
      } else if (Enums.FormType.processesForm.getKey() == toFormBean.getFormType()) {
        content.put("toFormType", ModuleType.collaboration.getValue());
      } 
      content.put("toVersion", formRelationshipMapBean.getRelationshipBean().getTargetFormVersion());
      content.put("fromRelationAttr", fromRelationAttr);
      if (Enums.FormType.processesForm.getKey() == toFormBean.getFormType()) {
        Long summaryId = masterDataId2SummeryId.get(Long.valueOf(dataId));
        content.put("summaryId", String.valueOf(summaryId));
        content.put("dataId", String.valueOf(summaryId));
      } else {
        content.put("dataId", dataId);
      } 
      if (isTree) {
        content.put("operable", Boolean.valueOf(MapUtils.getBooleanValue(relationData, "operable")));
        content.put("path", MapUtils.getString(relationData, "path"));
        content.put("parentId", MapUtils.getString(relationData, "parentId"));
        content.put("level", MapUtils.getInteger(relationData, "level"));
      } 
      contents.add(content);
    } 
    return contents;
  }
}
